var ToolType = {
	sword: {
		isWeapon: true,
		damage: 4,
		blockTypes: ["fibre", "corweb"],
		enchantType: Native.EnchantType.weapon
	},
	
	shovel: {
		enchantType: Native.EnchantType.shovel,
		damage: 2,
		blockTypes: ["dirt"],
		useItem: function(coords, item, block){
			if(block.id==2&&coords.side==1){ 
				World.setBlock(coords.x, coords.y, coords.z, 198);
				World.playSoundAtEntity(Player.get(), "step.grass", 0.5, 0.75);
				ToolAPI.breakCarriedTool(1);
			}
		}
	},
	
	pickaxe: {
		enchantType: Native.EnchantType.pickaxe,
		damage: 2,
		blockTypes: ["stone"]
	},
	
	axe: {
		enchantType: Native.EnchantType.axe,
		damage: 3,
		blockTypes: ["wood"]
	},
	
	hoe: {
		useItem: function(coords, item, block){
			if((block.id==2 || block.id==3) && coords.side==1){ 
				World.setBlock(coords.x, coords.y, coords.z, 60);
				World.playSoundAtEntity(Player.get(), "step.grass", 0.5, 0.75);
				ToolAPI.breakCarriedTool(1);
			}
		}
	}
}

ToolAPI.breakCarriedTool = function(damage){
	var item = Player.getCarriedItem(true);
	item.data += damage;
	if(item.data > Item.getMaxDamage(item.id)){
		item.id = 0;
	}
	Player.setCarriedItem(item.id, item.count, item.data, item.enchant);
}

ToolAPI.setTool = function(itemID, toolProperties, toolType){
	Item.setToolRender(itemID, true);
	if(ToolAPI.toolMaterials[toolProperties]){
	toolProperties = ToolAPI.toolMaterials[toolProperties];}
	if(toolType.blockTypes){
		ToolAPI.registerTool(itemID, toolProperties, toolType.blockTypes, toolType);
	}
	else{
		Item.setMaxDamage(itemID, toolProperties.durability);
	}
	if(toolType.useItem){
		Item.registerUseFunctionForID(itemID, toolType.useItem);
	}
	if(toolType.enchantType){
		Item.setEnchantType(itemID, toolType.enchantType, toolProperties.enchantability);
	}
}

registerAPIUnit("ToolType", ToolType);